unit cLVHeaderSortIcons;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  type
    SortOrderConstants = (
      soAscending = 0,  // lvwAscending
      soDescending = 1 // lvwDescending
      );

  type
    TcLVHeaderSortIcons =
      class
        private
          //
          // Copyright  1997-2000 Brad Martinez, http://www.mvps.org
          //
          // We're using IE3 definitions
          m_ListView : ListView; 
          m_himl : longint; 
          function Header_SetItem( var hwndHD : longint; var i : longint; var phdi : HDITEM ) : boolean;
          function ImageList_AddIcon( var himl : longint; var hIcon : longint ) : longint;
        public
          //
          constructor Create;
          destructor Destroy; override;
          function SetHeaderIcons( var iActiveColumn : longint; var iSortOrder : SortOrderConstants ) : boolean;
          function Get_ListView : ListView;
          procedure Set_ListView( var lv : olevariant );
          property ListView : ListView read Get_ListView write Set_ListView;
      end;

implementation

  const
    // ============================================================
    // listview definitions
    // messages
    LVM_FIRST = $00001000; 
    // ============================================================
    // header definitions
    // messages
    HDM_FIRST = $00001200; 
    HDM_SETITEM = ( HDM_FIRST + 4 ); 
    // HDITEM mask
    HDI_FORMAT = $00000004; 
    // HDITEM fmt
    HDF_LEFT = 0; 
    HDF_RIGHT = 1; 
    HDF_STRING = $00004000; 
    // ============================================================
    // imagelist definitions
    // ImageList_Create flags
    ILC_MASK = $00000001; 
    ILC_COLOR8 = $00000008; 

  type
    HDITEM =  // was HD_ITEM
      packed record
        mask : longint; 
        cxy : longint; 
        pszText : widestring;  // if retrieving text, must be pre-allocated
        hbm : longint; 
        cchTextMax : longint; 
        fmt : longint; 
        lParam : longint; 
      end;

  function SendMessage( hwnd : longint; wMsg : longint; wParam : longint; var lParam ) : longint; stdcall; external 'user32' name 'SendMessageA';
  function ImageList_Create( cx : longint; cy : longint; flags : longint; cInitial : longint; cGrow : longint ) : longint; stdcall; external 'comctl32.dll';
  function ImageList_Destroy( himl : longint ) : boolean; stdcall; external 'comctl32.dll';
  function ImageList_ReplaceIcon( himl : longint; i : longint; hIcon : longint ) : longint; stdcall; external 'comctl32.dll';

  constructor TcLVHeaderSortIcons.Create;
    begin
      m_himl := ImageList_Create( 16, 16, ILC_MASK or ILC_COLOR8, 2, 0 );
      if m_himl
        then
          begin
            // Load the icons into the image so that their zero-based
            // indicescorrespond to the SortOrderConstants values.
            ImageList_AddIcon( m_himl, LoadPicture( App.Path + '\sortascending.ico' ) );
            ImageList_AddIcon( m_himl, LoadPicture( App.Path + '\sortdescending.ico' ) );
          end;
    end;

  destructor TcLVHeaderSortIcons.Destroy;
    begin
      if m_himl
        then
          begin
            ImageList_Destroy( m_himl );
          end;
    end;

  // Sets and removes header sort order icons
  function TcLVHeaderSortIcons.SetHeaderIcons( var iActiveColumn : longint; var iSortOrder : SortOrderConstants ) : boolean;
    const
      {$WRITEABLECONST ON}
      hwndHdr : longint = 0;
      {$WRITEABLECONST OFF}
    var
      i : longint; 
      fShow : boolean; 
      fAlignRight : boolean; 
      hdi : HDITEM; 
    begin
      if ( m_himl = 0 ) or ( m_ListView = nil )
        then
          begin
            exit;
          end;
      if ( m_ListView.View <> lvwReport )
        then
          begin
            exit;
          end;
      // <new>
      // The ListView's header is created *after* the first
      // ColumnHeader is added.
      if ( hwndHdr = 0 )
        then
          begin
            hwndHdr := ListView_GetHeader( m_ListView.hwnd );
          end;
      if ( hwndHdr = 0 )
        then
          begin
            exit;
          end;
      Header_SetImageList( hwndHdr, m_himl );
      // </new>
      with m_ListView.ColumnHeaders do
        begin
          for i := 0 to Count - 1 do
            begin
              hdi.mask := HDI_FORMAT or HDI_IMAGE;
              fAlignRight := ( Item( i + 1 ).Alignment = lvwColumnRight );
              // Since we're setting the header's format, we have to
              // specify the string flag
              hdi.fmt := HDF_STRING or ( fAlignRight and HDF_RIGHT ); // HDF_LEFT = 0
              // If the active column, add the sort icon with the appropriate
              // alignment (the icon is removed if HDF_IMAGE is not set).
              if ( i = iActiveColumn )
                then
                  begin
                    hdi.fmt := hdi.fmt or HDF_IMAGE or ( ( fAlignRight = false ) and HDF_BITMAP_ON_RIGHT );
                  end;
              // If not the soAscending icon index (0), then set to
              // the soDescending (1) icon index.
              hdi.iImage := Abs( VarAsType( iSortOrder, varBoolean ) );
              Header_SetItem( hwndHdr, i, hdi );
            end;
        end;
      result := true;
    end;

  // ============================================================
  // listview, header, imagelist macros
  function TcLVHeaderSortIcons.Header_SetItem( var hwndHD : longint; var i : longint; var phdi : HDITEM ) : boolean;
    begin
      result := SendMessage( hwndHD, HDM_SETITEM, i, phdi );
    end;

  function TcLVHeaderSortIcons.ImageList_AddIcon( var himl : longint; var hIcon : longint ) : longint;
    begin
      result := ImageList_ReplaceIcon( himl, -1, hIcon );
    end;

  function TcLVHeaderSortIcons.Get_ListView : ListView;
    begin
      result := m_ListView;
    end;

  procedure TcLVHeaderSortIcons.Set_ListView( var lv : olevariant );
    begin
      m_ListView := lv;
    end;

end.
