Attribute VB_Name = "MComCtrlStyles"
Option Explicit

' Brought to you by:
'   Brad Martinez
'   btmtz@msn.com
'   btmtz@aol.com
'   http://members.aol.com/btmtz/vb

' ========================================================
' Prototypes were extracted and translated from Commctrl.h v1.2
' which can be found at:
' http://www.microsoft.com/msdn/sdk/platforms/doc/sdk/headers/c35.htm

' Descriptions and syntax were extracted from the Win32 SDK
' also available at: http://www.microsoft.com/win32dev/wcnt.htm

' Both URLs were valid 06/19/97, the time of this writing.
' ========================================================

' //====== COMMON CONTROL STYLES =====================

' Following are the common control styles. Except where noted, these
' styles apply to header controls, toolbar controls, and status windows.

' Causes the control to position itself at the top of the parent window's client
' area and sets the width to be the same as the parent window's width.
' Toolbars have this style by default.
Public Const CCS_TOP = &H1&

' Causes the control to resize and move itself horizontally, but not vertically,
' in response to a WM_SIZE message. If CCS_NORESIZE is used, this style
' does not apply. Header windows have this style by default.
Public Const CCS_NOMOVEY = &H2&

' Causes the control to position itself at the bottom of the parent window's
' client area and sets the width to be the same as the parent window's width.
' Status windows have this style by default.
Public Const CCS_BOTTOM = &H3&

' Prevents the control from using the default width and height when setting its
' initial size or a new size. Instead, the control uses the width and height
' specified in the request for creation or sizing.
Public Const CCS_NORESIZE = &H4&

' Prevents the control from automatically moving to the top or bottom of the parent
' window. Instead, the control keeps its position within the parent window despite
' changes to the size of the parent. If CCS_TOP or CCS_BOTTOM is also used,
' the height is adjusted to the default, but the position and width remain unchanged.
Public Const CCS_NOPARENTALIGN = &H8&

' Prevents a one-pixel highlight from being drawn at the top of the control.
Public Const CCS_NOHILITE = &H10&

' Enables a toolbar's built-in customization features, which allow the user to drag
' a button to a new position or to remove a button by dragging it off the toolbar. In
' addition, the user can double-click the toolbar to display the Customize Toolbar
' dialog box, allowing the user to add, delete, and rearrange toolbar buttons.
Public Const CCS_ADJUSTABLE = &H20&

' Prevents a two-pixel highlight from being drawn at the top of the control.
Public Const CCS_NODIVIDER = &H40&
