unit MComCtrlInit;

// DISCLAIMER!
// ==================================================================
// This source code has been automatically generated.
// It still requires extensive manual fixing, debugging and testing.
// IT IS NOT GUARANTEED TO COMPILE
// AND MUCH LESS TO BEHAVE EXACTLY LIKE THE ORIGINAL SOURCE CODE.
// Use it at your sole risk and discretion.
//

interface

  const
    // Set of bit flags that indicate which common control classes will be loaded
    // from the DLL. The dwICC value can be a combination of the following:
    ICC_LISTVIEW_CLASSES : smallint = $00000001;  // listview, header
    ICC_TREEVIEW_CLASSES : smallint = $00000002;  // treeview, tooltips
    ICC_BAR_CLASSES : smallint = $00000004;  // toolbar, statusbar, trackbar, tooltips
    ICC_TAB_CLASSES : smallint = $00000008;  // tab, tooltips
    ICC_UPDOWN_CLASS : smallint = $00000010;  // updown
    ICC_PROGRESS_CLASS : smallint = $00000020;  // progress bar
    ICC_HOTKEY_CLASS : smallint = $00000040;  // hotkey
    ICC_ANIMATE_CLASS : smallint = $00000080;  // animate control class
    ICC_WIN95_CLASSES : smallint = $000000FF;  // loads everything above
    ICC_DATE_CLASSES : smallint = $00000100;  // month picker, date picker, time picker, updown
    ICC_USEREX_CLASSES : smallint = $00000200;  // comboex
    ICC_COOL_CLASSES : smallint = $00000400;  // rebar (coolbar) control

  type
    tagINITCOMMONCONTROLSEX =  // icc
      packed record
        dwSize : longint;  // size of this structure
        dwICC : longint;  // flags indicating which classes to be initialized.
      end;

  // Returns True if the current working version of Comctl32.dll is
  // available on the system and the new IE3 sytles and messages
  // can be used. Returns False either if the old version is present or
  // Comctl32.dll isn't available at all. Also ensures that the library is
  // loaded for use.
  // We can get away with this hack rather than checking the file's
  // version because VB resolves declared API function names only
  // when they're called, not when it compiles the code...
  function InitComctl32( var dwFlags : longint ) : boolean;

  // =============================================
  // At some point early on in the status bar's life this message may have been supported
  // but apparenty is not anymore...
  // From "Win32 Common Controls, Part 2: Status Bars and Toolbars"
  // Nancy Winnick Cluts. Microsoft Developer Network Technology Group, March 1994
  // The SB_SETBORDERS message sets the widths of the horizontal and vertical borders
  // of a status bar or header window. These borders determine the spacing between the
  // outer edge of the window and the rectangles within the window that contain text, and the
  // spacingbetween rectangles.
  // wParam = 0, not used
  // lParam = The address of an integer array that has three elements. The first element
  //               specifies the width of the horizontal border, the second specifies the width of
  //               the vertical border, and the third specifies the width of the border between
  //               rectangles. If an element is set to 1, the default width for the border is used.
  // Rtns True on success, False if failure
  //Public Const SB_SETBORDERS = (WM_USER + ?)
  // =============================================================
  // Brought to you by:
  //   Brad Martinez
  //   btmtz@msn.com
  //   btmtz@aol.com
  //   http://members.aol.com/btmtz/vb
  // ========================================================
  // Prototypes were extracted and translated from Commctrl.h v1.2
  // which can be found at:
  // http://www.microsoft.com/msdn/sdk/platforms/doc/sdk/headers/c35.htm
  // Descriptions and syntax were extracted from the Win32 SDK
  // also available at: http://www.microsoft.com/win32dev/wcnt.htm
  // Both URLs were valid 06/19/97, the time of this writing.
  // ========================================================
  // Initializes the entire common control dynamic-link library.
  // Exported by all versions of Comctl32.dll.
  procedure InitCommonControls; stdcall; external 'comctl32.dll';
  // Initializes specific common controls classes from the common
  // control dynamic-link library.
  // Returns TRUE (non-zero) if successful, or FALSE otherwise.
  // Began being exported with Comctl32.dll version 4.7 (IE3.0 & later).
  function InitCommonControlsEx( var lpInitCtrls : tagINITCOMMONCONTROLSEX ) : boolean; stdcall; external 'comctl32.dll';

implementation

  function InitComctl32( var dwFlags : longint ) : boolean;
    var
      icc : tagINITCOMMONCONTROLSEX; 
    label
      Err_OldVersion;
    begin
      //ON ERROR
      icc.dwSize := sizeof( icc );
      icc.dwICC := dwFlags;
      // VB will generate error 453 "Specified DLL function not found"
      // here if the new version isn't installed and it can't find the function's
      // name. We'll hopefully be able to load the old version below...
      result := InitCommonControlsEx( icc );
      exit;
      Err_OldVersion:
      InitCommonControls;
    end;

end.
